<?php

/**
 * co_modalidad_sel actions.
 *
 * @package    contratacion
 * @subpackage co_modalidad_sel
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_modalidad_selActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CO_MODALIDAD_SEL', 'CO_TIPO_PROCESO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_TIPO_PROCESO' =>
        array(
            'id_tipo_proceso' => 'CO_MODALIDAD_SEL'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'id_modalidad_sel',
            'descripcion' => 'descripcion',
            'fundamentos_juridicos' => 'fundamentos_juridicos',
            'id_tipo_proceso' => 'id_tipo_proceso',
            'estado' => 'estado',
            'prefijo' => 'prefijo',
            'introductorio' => 'introductorio',
            'cuantia_min' => 'cuantia_min',
            'cuantia_max' => 'cuantia_max',
            'introductorio' => 'introductorio',
            'aplica_proceso' => 'aplica_proceso',
            'aplica_aprobacion' => 'aplica_aprobacion',
            'mod_sireci_siges' => 'mod_sireci_siges',
            'id_mod_sireci_siges' => 'id_mod_sireci_siges',
            'aplica_supervisor' => 'aplica_supervisor',
            'aplica_contratista' => 'aplica_contratista',
            'aplica_revisiones' => 'aplica_revisiones',
        ),
        'CO_TIPO_PROCESO' =>
        array(
            'codigo' => 'codigo_proceso',
            'descripcion' => 'descripcion_proceso'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'descripcion'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel,a' => array('!=' => array(-1)),
            'id_modalidad_sel,b' => array('=' => array('id_modalidad_sel')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion', '%')),
            'id_tipo_proceso' => array('=' => array('id_tipo_proceso')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_TIPO_PROCESO' =>
        array(
            'codigo,a' => array('LIKEALLPLUS' => array('codigo_proceso', '%')),
            'descripcion,a' => array('LIKEALLPLUS' => array('descripcion_proceso', '%'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_modalidad_sel'; //identificador de la tabla
    protected $id_names = array('id_modalidad_sel'); //llave primaria
    protected $field_names = array('descripcion', 'fundamentos_juridicos', 'id_tipo_proceso',
        'estado', 'prefijo', 'cuantia_min', 'cuantia_max',
        'introductorio', 'aplica_proceso', 'aplica_aprobacion','aplica_supervisor','aplica_contratista','aplica_revisiones'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_MODALIDAD_SEL'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_modalidad_sel'; //identificador unico de la tabla

    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
            $this->conn->beginTransaction();
            try {

                $id_modalidad_sel = $list_data_post[0]['id_modalidad_sel'];


                $sql = <<<EOD
SELECT 
rownum as orden,
tab0.id_campo_ep
FROM CO_CAMPO_EP tab0
WHERE 1=1 AND tab0.campo_fijo = 1 
ORDER BY tab0.id_campo_ep
EOD;

                $records = CN_TABLE::executeSQL($sql);

                foreach ($records as $campos) {

                    $id_campo_ep_fijo = $campos['id_campo_ep'];
                    $orden_fijo = $campos['orden'];
                    $estado_fijo = 1;

                    $sql = <<<EOD
INSERT INTO CO_CAMPO_MODALIDAD (ID_CAMPO_MODALIDAD,ID_MODALIDAD_SEL,CAMPO_EP,ORDEN,ESTADO) VALUES ('','$id_modalidad_sel',(SELECT REF(e) FROM CO_CAMPO_EP e WHERE e.ID_CAMPO_EP=$id_campo_ep_fijo),'$orden_fijo',$estado_fijo)
EOD;
                    $this->conn->execute($sql);
                }



                $this->conn->commit();
            } catch (Exception $e) {

                //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
                $this->conn->rollback();
            }
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */
        $id_modalidad_sel = $request['id_modalidad_sel'];

        $sql = <<<EOD
        select count(*) as cantidad from co_estudios_previos tab0
                where id_modalidad_sel = $id_modalidad_sel
EOD;
        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        /*
         *  Generar errores en $errors
         */
        if ($cantidad > 0) {
            $errors['mensaje'] = "No se puede eliminar, Existen estudios previos pertenecientes a esta modalidad de seleccion.";
            $errors['servicio'] = "co_modalidad_sel";
        }

        return $errors;
    }

    protected function validateUpdate(sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
